<?php
/**
* Author: LeeFish
* Copyright:  2010 LeeFish
* Website:  http://www.LeeFish.nl
* This plugin is not to be distributed outside of mybb.com or leefish.nl - do not upload to your own site to distribute
**/

// Disallow direct access to this file for security reasons
if(!defined("IN_MYBB"))
{
	die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
}

$plugins->add_hook("usercp_start", "bbdownloadsonucp_run");

function bbdownloadsonucp_info()
{
	return array(
		"name"       	=> "<img border=\"0\" src=\"../images/usercp/subscriptions.png\" align=\"absbottom\" /> Latest Stats for Attachment Downloads on UserCP",
		"description"	=> "Shows how many times a users attachments have been downloaded on usercp home.",
		"website"		=> "http://www.LeeFish.nl",
		"author"		=> "LeeFish & compat update by Vintagedaddyo",
		"authorsite"	=> "http://www.LeeFish.nl/mybb/forumdisplay.php?fid=51",
		"version"		=> "1.1",
		"guid"          => "af3b38dce9801d55d7bd37ebeb42c49c",
		"compatibility" => "18*",
	);
}

function bbdownloadsonucp_install()
{
	global $db;
	
	$query = $db->simple_select("settinggroups", "COUNT(*) as `rows`");
	$darows = $db->fetch_field($query, "rows");
	
	$insertarray = array(
		'name' => 'bbdownloadsonucp', 
		'title' => 'MyBB Attachments Downloads Stats on UserCP Home', 
		'description' => 'MyBB Attachments Downloads Stats on UserCP Home Settings', 
		'disporder' => $darows+1, 
		'isdefault' => 0
	);
	$db->insert_query("settinggroups", $insertarray);
	$group['gid'] = $db->insert_id();
	
	$insertarray = array(
		'name' => 'bbdownloadsonucp_showuploadstats',
		'title' => 'Show MyBB Attachments Downloads Stats on UserCP Home?',
		'description' => 'Show Attachment Stats on UserCP Home?',
		'optionscode' => 'onoff',
		'value' => 1,
		'disporder' => 0,
		'gid' => $group['gid']
	);
	$db->insert_query("settings", $insertarray);
	
		$insertarray = array(
		'name' => 'bbdownloadsonucp_keys',
		'title' => 'Which MYBB attachment downloads do you want to show?',
		'description' => 'Select the file type you wish to include from the attachment types panel, separate each key with a comma <br /><strong>NO SPACES</strong>',
		'optionscode' => 'text',
		'value' => 'image/bmp,text/css,application/msword,application/vnd.openxmlformats-officedocument.wordprocessingml.document,image/gif,application/x-gzip,text/html,image/jpeg,application/pdf,application/x-httpd-php,image/png,application/vnd.ms-powerpoint,application/vnd.openxmlformats-officedocument.presentationml.presentation,application/x-photoshop,application/x-tar,text/plain,application/vnd.ms-excel,application/vnd.openxmlformats-officedocument.spreadsheetml.sheet,application/zip',
		'disporder' => 1,
		'gid' => $group['gid']
	);
	$db->insert_query("settings", $insertarray);

	rebuild_settings();
}

function bbdownloadsonucp_is_installed()
{
	global $db;
	
	$query = $db->query("SELECT COUNT(*) AS num FROM ".TABLE_PREFIX."settinggroups WHERE name='bbdownloadsonucp'");
	$num = $db->fetch_array($query);
	
	if($num['num'] > "0")
	{
		return true;
	}
	
	return false;
}


function bbdownloadsonucp_activate()
{
	global $db, $mybb;
	
	include MYBB_ROOT."/inc/adminfunctions_templates.php";
	
	find_replace_templatesets("usercp", '#{\$latest_subscribed}(\r?)\n#', "{\$mybb_upload_stats}\n{\$latest_subscribed}\n");
	
	$db->insert_query("templates", $insert_array);
	
	$insert_array = array(
		'title' => "usercp_mybbuploadstats",
		        'template'    => $db->escape_string('<br />
    <table border="0" cellspacing="{$theme[\'borderwidth\']}" cellpadding="{$theme[\'tablespace\']}" class="tborder">
        <thead>
            <tr>
                <td class="thead" colspan="7">
                    <div><strong>{$lang->bbdownloadsonucp_mybbuploadstats}</strong></div>
                </td>
            </tr>
            <tr>
                <td class="tcat" width="6%">&nbsp;<br /> </td>
                <td class="tcat" width="30%"><span class="smalltext"><strong><a href="usercp.php?sortby=subject&amp;order=asc">{$lang->bbdownloadsonucp_thread}</a><br />  {$orderarrow[\'subject\']}</strong></span></td>
                <td class="tcat" width="19%" align="left"><span class="smalltext"><strong><a href="usercp.php?sortby=forum&amp;order=asc">{$lang->bbdownloadsonucp_forum}</a> <br /> {$orderarrow[\'forum\']}</strong></span></td>
                <td class="tcat" width="10%" align="center"><span class="smalltext"><strong><a href="usercp.php?sortby=downloads&amp;order=asc">{$lang->bbdownloadsonucp_downloads}</a> <br /> {$orderarrow[\'downloads\']}</strong></span></td>
                <td class="tcat" width="10%" align="center"><span class="smalltext"><strong><a href="usercp.php?sortby=comments&amp;order=asc">{$lang->bbdownloadsonucp_replies}</a><br /> {$orderarrow[\'comments\']}</strong></span></td>
                <td class="tcat" width="10%" align="center"><span class="smalltext"><strong><a href="usercp.php?sortby=views&amp;order=asc">{$lang->bbdownloadsonucp_views}</a><br /> {$orderarrow[\'views\']}</strong></span></td>
                <td class="tcat" width="15%" align="right"><span class="smalltext"><strong>{$lang->bbdownloadsonucp_lastposter}</strong></span></td>
            </tr>
        </thead>
        <tbody>
        {$mybbuploadstats}
        </tbody>
        <tfoot>
            <tr>
                <td class="tfoot" width="6%">&nbsp;</td>
                <td class="tfoot" width="30%"><span class="smalltext"><strong>{$lang->bbdownloadsonucp_summary}</strong></span></td>
                <td class="tfoot" width="19%" align="left"><span class="smalltext"><strong>&nbsp;</strong></span></td>
                <td class="tfoot" width="10%" align="center"><span class="smalltext"><strong>{$total_downloads}</strong></span></td>
                <td class="tfoot" width="10%" align="center"><span class="smalltext"><strong>{$total_replies}</strong></span></td>
                <td class="tfoot" width="10%" align="center"><span class="smalltext"><strong>{$total_views}</strong></span></td>
                <td class="tfoot" width="15%" align="right"><span class="smalltext"><strong>&nbsp;</strong></span></td>
            </tr>
        </tfoot>
        </table>'),
		'sid' => "-1",
		'version' => "",
		'dateline' => TIME_NOW
	);
	
	$db->insert_query("templates", $insert_array);
	
	$insert_array = array(
		'title' => "usercp_mybbuploadstats_threads",
		'template' => "<tr>
		<td class=\"trow1\" align=\"center\">{\$icon}</td>
		<td class=\"trow2\"><a href=\"{\$threadlink}\" title=\"{\$mdb[\'threadsubject\']}\">{\$mdbthreadsubject}</a></td>
		<td class=\"trow1\" align=\"left\"><a href=\"{\$forumlink}\" title=\"{\$mdb[\'forumname\']}\">{\$mdbforumname}</a></td>
		<td class=\"trow2\" align=\"center\">{\$downloads}</td>
		<td class=\"trow2\" align=\"center\">{\$replies}</td>
		<td class=\"trow1\" align=\"center\">{\$views}</td>
		<td class=\"trow2\" align=\"right\">{\$lastposter}</td>
</tr>
",
		'sid' => "-1",
		'version' => "",
		'dateline' => TIME_NOW
	);
	
	$db->insert_query("templates", $insert_array);
	
}

function bbdownloadsonucp_deactivate()
{
	global $db, $mybb;
	
	include MYBB_ROOT."/inc/adminfunctions_templates.php";
	
	find_replace_templatesets("usercp", '#{\$mybb_upload_stats}(\r?)\n#', "", 0);
	
	$db->delete_query("templates", "title = 'usercp_mybbuploadstats'");
	$db->delete_query("templates", "title = 'usercp_mybbuploadstats_threads'");
	
}

function bbdownloadsonucp_uninstall()
{
	global $db;
	
	// DELETE ALL SETTINGS TO AVOID DUPLICATES
	$db->write_query("DELETE FROM ".TABLE_PREFIX."settings WHERE name IN(
		'bbdownloadsonucp_showuploadstats'
		'bbdownloadsonucp_keys'
	)");
	$db->delete_query("settinggroups", "name = 'bbdownloadsonucp'");
	rebuild_settings();
}

$plugins->add_hook('global_start', 'bbdownloadsonucp_tcache');
function bbdownloadsonucp_tcache(){
	if(THIS_SCRIPT == 'usercp.php'){
		if(isset($GLOBALS['templatelist'])){
			$GLOBALS['templatelist'] .= ',usercp_mybbuploadstats,usercp_mybbuploadstats_threads';
		}
	}
}

function bbdownloadsonucp_run()
{
	global $db, $mybb, $templates, $theme, $lang, $mybb_upload_stats;

	$lang->load("bbdownloadsonucp");
	
	// Figure out which sort field to use
    switch($mybb->input['sortby'])
    {
	    case "date":
        default:
            // Order by thread date
            $sortfield = "threaddate";
            $sortby = "date";
            break;
        case "subject":
            // Order by thread subject
            $sortfield = "threadsubject";
            $sortby = "subject";
            break;
		case "forum":
            // Order by thread subject
            $sortfield = "forumname";
            $sortby = "forum";
            break;
        case "downloads": 
            // Order by the downloads
            $sortfield = "downloads";
            $sortby = "downloads";
            break;
        case "comments":
            // Order by comments
            $sortfield = "t.replies";
            $sortby = "comments";
            break;
        case "views":
            // Order by views
            $sortfield = "t.views";
            $sortby = "views";
            break;
    }

    // Figure out which sort order to use
    switch($mybb->input['order'])
    {
        case "asc":
            $sortorder = "ASC";
            $order = "asc";
            $alt_order = "desc";
            break;
        case "desc":
        default:
            $sortorder = "DESC";
            $order = "desc";
            $alt_order = "asc";
    }


    // From our URL, pick which heading to choose as our 'active' header
    // This provides a way for reversing the order in a URL
    if($mybb->input['sortby'])
    {
        $page_url .= "?sortby=".$sortby;
    }

    $orderarrow = array();
    $orderarrow[$sortby] = "[ <a href=\"".$page_url."&amp;order=".$alt_order."\">".$alt_order."</a> ]";

    if($mybb->input['order'])
    {
        $page_url .= "&amp;order=".$order;
    }
	
	if($mybb->settings['bbdownloadsonucp_showuploadstats'] == "1")
	{	
		$bbdownloadsonucp_keys = $mybb->settings['bbdownloadsonucp_keys'];
			if(is_array(explode(',', $mybb->settings['bbdownloadsonucp_keys'])))
		{
			foreach(explode(',', $mybb->settings['bbdownloadsonucp_keys']) as $filetype_tid)
			{
				$filetype_tid_array[] = $filetype_tid;
			}
		}
		$downloadsucp_icon_cache = $GLOBALS['cache']->read('posticons');	
		$mdbquery = $db->query("
			SELECT p.subject AS threadsubject, p.username AS tusername, t.tid, t.views, p.icon, t.replies, u.username, u.usergroup, u.displaygroup, SUM(a.downloads) AS downloads, i.*, i.name AS iconname,
			f.name AS forumname, p.dateline AS threaddate, f.fid
			FROM (".TABLE_PREFIX."posts p
			INNER JOIN ".TABLE_PREFIX."attachments a ON (a.pid=p.pid))
			LEFT JOIN ".TABLE_PREFIX."threads t ON (t.tid=p.tid)
			LEFT JOIN ".TABLE_PREFIX."forums f ON (f.fid=t.fid)
			LEFT JOIN ".TABLE_PREFIX."icons i ON (i.iid=p.icon)
			LEFT JOIN ".TABLE_PREFIX."users u ON (t.lastposter=u.username)
			WHERE p.uid = '".$mybb->user['uid']."'
			AND p.visible = '1'
			AND a.filetype IN('".implode("','", $filetype_tid_array)."')
			GROUP BY t.tid
			ORDER BY a.downloads DESC
		");
				
		while($mdb = $db->fetch_array($mdbquery))
		{	
			if($mdb['icon'] > 0 && $downloadsucp_icon_cache[$mdb['icon']])
			{
				$icon = $downloadsucp_icon_cache[$mdb['icon']];
				$icon = "<img src=\"{$mdb['path']}\" alt=\"{$mdb['iconname']}\" title=\"{$mdb['iconname']}\" />";
			}
			else
			{
				$icon = "&nbsp;";
			}
			if($mdb['lastposteruid'] == 0)
			{
				$lastposter;
			}
			else
			{
				$lastposter = "Guest";	
			}
					
            $mdbthreadsubject = htmlspecialchars_uni($mdb['threadsubject']);
			$mdbforumname = $mdb['forumname'];
			$threadlink = get_thread_link($mdb['tid']);
			$forumlink = get_forum_link($mdb['fid']);
			$downloads = my_number_format($mdb['downloads']);
			$replies = my_number_format($mdb['replies']);
			$views = my_number_format($mdb['views']);
			$lastposter = format_name($mdb['username'], $mdb['usergroup'], $mdb['displaygroup']);
			$lastposter = build_profile_link($lastposter, $mdb['lastposteruid']);
			$total_downloads += $mdb['downloads'];
			$total_replies += $mdb['replies'];
			$total_views += $mdb['views'];
	
			eval("\$mybbuploadstats .= \"".$templates->get("usercp_mybbuploadstats_threads")."\";");
	
		}
		
		if($mybbuploadstats)
		{
			eval("\$mybb_upload_stats = \"".$templates->get("usercp_mybbuploadstats")."\";");
		}
		
		
			
	}
	
}

?>